import { type ContextDelegation } from '@eggjs/koa';
import { FileLoader, type FileLoaderOptions } from './file_loader.js';
export interface ClassLoaderOptions {
    ctx: ContextDelegation;
    properties: any;
}
export declare class ClassLoader {
    #private;
    readonly _cache: Map<any, any>;
    _ctx: ContextDelegation;
    constructor(options: ClassLoaderOptions);
}
export interface ContextLoaderOptions extends Omit<FileLoaderOptions, 'target'> {
    /** required inject */
    inject: Record<string, any>;
    /** property name defined to target */
    property: string | symbol;
    /** determine the field name of inject object. */
    fieldClass?: string;
}
/**
 * Same as {@link FileLoader}, but it will attach file to `inject[fieldClass]`.
 * The exports will be lazy loaded, such as `ctx.group.repository`.
 * @augments FileLoader
 * @since 1.0.0
 */
export declare class ContextLoader extends FileLoader {
    #private;
    /**
     * @class
     * @param {Object} options - options same as {@link FileLoader}
     * @param {String} options.fieldClass - determine the field name of inject object.
     */
    constructor(options: ContextLoaderOptions);
}
